## maxima 5.47.0

=== crosscompile-windows/CMakeLists.txt ===
# CMake file for crosscompiling Maxima/wxMaxima for Windows
# SPDX-License-Identifier: GPL-2.0-or-later
# Copyright (C) by Wolfgang Dautermann
# License GPLv2+: GNU GPL version 2 or later <http://gnu.org/licenses/gpl.html>
# This is free software: you are free to change and redistribute it.
# There is NO WARRANTY, to the extent permitted by law.

set(CMAKE_SYSTEM_NAME Windows)

option(BUILD_64BIT "Build a 64 bit installer." YES)

if(BUILD_64BIT)
    set(HOST x86_64-w64-mingw32)
    set(INSTALLERSUFFIX "win64")
else()
    set(HOST i686-w64-mingw32)
    set(INSTALLERSUFFIX "win32")
endif()

set(CMAKE_C_COMPILER   ${HOST}-gcc)
set(CMAKE_CXX_COMPILER ${HOST}-g++)
set(CMAKE_RC_COMPILER  ${HOST}-windres)

cmake_minimum_required(VERSION 3.10)
project(maxima)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/ ${CMAKE_BINARY_DIR}/)


# On which windows drive (C:, D:, ...) will be the default installation path?
set(WINDOWS_DRIVELETTER "C")


# What is the build system?
execute_process(COMMAND gcc -dumpmachine OUTPUT_VARIABLE BUILDHOST OUTPUT_STRIP_TRAILING_WHITESPACE)
message(STATUS "Build system: ${BUILDHOST}")

# Output the host system, for which we are compiling
message(STATUS "Host system: ${HOST}")

find_file(NSISTEMPLATE_IN  NAMES "NSIS.template.in"
    PATHS "${CMAKE_ROOT}/Modules/" "${CMAKE_ROOT}/Modules/Internal/CPack")
file(READ "${NSISTEMPLATE_IN}" MYNSISTEMPLATE)
string(REPLACE "RequestExecutionLevel admin" "RequestExecutionLevel admin
!include FileFunc.nsh
!include LogicLib.nsh
" MYNSISTEMPLATE "${MYNSISTEMPLATE}")

string(REPLACE "Function .onInit" "Function .onInit
\${GetParameters} \$0
\${GetOptions} \$0 \"/no_vtk\" \$1
\${IfNot} \${Errors}
    !insertmacro UnselectSection \${vtk}
\${EndIf}
\${GetOptions} \$0 \"/no_gnuplot\" \$1
\${IfNot} \${Errors}
    !insertmacro UnselectSection \${gnuplot}
\${EndIf}
\${GetOptions} \$0 \"/no_wxmaxima\" \$1
\${IfNot} \${Errors}
    !insertmacro UnselectSection \${wxmaxima}
\${EndIf}
\${GetOptions} \$0 \"/?\" \$1
\${IfNot} \${Errors}
        MessageBox MB_OK \"Installer for Maxima\$\\n\$\\nThis installer allows the following command line options:\$\\n        /S - silent install\$\\n        /D=<path> - select the install path\$\\n        /no_vtk - do not select VTK\$\\n        /no_gnuplot - do not select Gnuplot\$\\n        /no_wxmaxima - do not select wxMaxima\$\\n        /? - this help message\$\\n\$\\nMaxima Website: https://maxima.sourceforge.io\"
        Abort
\${EndIf}

" MYNSISTEMPLATE "${MYNSISTEMPLATE}")
file(WRITE ${CMAKE_BINARY_DIR}/NSIS.template.in "${MYNSISTEMPLATE}")
message(STATUS "Copied and patched ${NSISTEMPLATE_IN} to ${CMAKE_BINARY_DIR}/NSIS.template.in")

option(USE_WXMAXIMA_GIT "Use wxMaxima development snapshot." NO)
option(USE_VTK "Use VTK." YES)
# the following option is used for nightly builds of the installer.
# it builds the current Maxima/wxMaxima Git versions and also
# sets the installation directory to ${WINDOWS_DRIVELETTER}:\maxima-current
option(BUILD_CURRENT "Build a installer for current Maxima/wxMaxima." NO)

option(WITH_ABCL "Include ABCL in the installer." NO)

# SBCL and CLISP have both advantages and disadvantages:
#  - SBCL is fast, but sometimes runs out of memory in places it really shouldn't
#    (Loading LAPACK on IA32, for example) and isn't too happy with changing to
#    non-ascii-non-unicode pathnames (which wxMaxima works around by now, though,
#    and which Xmaxima doesn't evven try to do)
#  - CLISP is slow. And version 2.49 only sends valid output over the network
#    if the front-end is slow enough. Test cases: Running a demo, all commands
#    with loads of compiler output (load("draw"); for the first time) or just
#    receiving a batch of new autocompletion symbols. Since the libraries the
#    front-ends use have evolved in the last years it has become easy to
#    trigger this => Setting SBCL to be the default.
#  - ABCL (optional) is a Java based Lisp.
if(WITH_ABCL)
    set(WITH_DEFAULT_LISP "sbcl" CACHE STRING "Which Lisp should be used by default (clisp/sbcl/abcl)?")
    set_property(CACHE WITH_DEFAULT_LISP PROPERTY STRINGS "clisp" "sbcl" "abcl")
    set(ABCL_STYLE "")
    set(ABCL_ENABLED 1)
else()
    set(WITH_DEFAULT_LISP "sbcl" CACHE STRING "Which Lisp should be used by default (clisp/sbcl)?")
    set_property(CACHE WITH_DEFAULT_LISP PROPERTY STRINGS "clisp" "sbcl")
    set(ABCL_STYLE "display: none;")
    set(ABCL_ENABLED 0)
endif()

# If you want to use a updated version of a program,
# update the version number and the checksum.
# If no further patches are needed, you should get a
# updated setup-file automatically.

# current program versions
set(CLISPVERSION 2.49)


# MD5 checksums for the current program versions.
set(CLISP_MD5 "8d58d64f83dd7ad01c054aecc16c1f52")

if(BUILD_CURRENT)
    set(USE_WXMAXIMA_GIT YES)
    set(MAXIMAVERSION "current")
else()
    # Get Maxima version from configure.ac
    file(STRINGS "${CMAKE_SOURCE_DIR}/../configure.ac" CONFIGUREAC REGEX "AC_INIT\\(.*\\)")
    string(REGEX REPLACE "AC_INIT\\(\\[maxima\\],[ \t\r\n]*\\[(.*)\\]\\)" "\\1" MAXIMAVERSION ${CONFIGUREAC})
    message(STATUS "Maxima version (from configure.ac): ${MAXIMAVERSION}")
endif()

# The HTML documentation is installed in a directory depending on "git describe",
# when building from Git, e.g.:
# share/maxima/branch_5_45_base_99_g0b3357e40_dirty/doc/html/maxima_singlepage.html
# Otherwise the version number is included, e.g something like:
# share/maxima/5.45.1/doc/html/maxima_singlepage.html
# Set it first to the second variant, if Git is found and we are building
# from a Git tree use the result of "git describe --dirty" in the path instead - where
# "-" are changed to "_" (see commit d5d04f2 and the file '../configure.ac').
set(MAXIMA_SINGLEPAGE_HTML "share/maxima/${MAXIMAVERSION}/doc/html/maxima_singlepage.html")
find_package(Git)
if(Git_FOUND)
    execute_process(COMMAND ${GIT_EXECUTABLE} describe --dirty
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                    OUTPUT_VARIABLE GIT_DESCRIBE
                    ERROR_QUIET
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(GIT_DESCRIBE)
        string(REPLACE "-" "_" GIT_DESCRIBE ${GIT_DESCRIBE})
        set(MAXIMA_SINGLEPAGE_HTML "share/maxima/${GIT_DESCRIBE}/doc/html/maxima_singlepage.html")
    endif()
endif()

# download URLs
set(CLISP_URL "https://downloads.sourceforge.net/project/clisp/clisp/${CLISPVERSION}/clisp-${CLISPVERSION}-win32-mingw-big.zip")


# Where are libgcc and libstdc++?
if(BUILD_64BIT)
    execute_process(COMMAND "${CMAKE_CXX_COMPILER}" -print-file-name=libgcc_s_seh-1.dll OUTPUT_VARIABLE MINGW_LIBGCC    OUTPUT_STRIP_TRAILING_WHITESPACE)
else()
    execute_process(COMMAND "${CMAKE_CXX_COMPILER}" -print-file-name=libgcc_s_sjlj-1.dll OUTPUT_VARIABLE MINGW_LIBGCC    OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()

execute_process(COMMAND "${CMAKE_CXX_COMPILER}" -print-file-name=libstdc++-6.dll     OUTPUT_VARIABLE MINGW_LIBSTDCPP OUTPUT_STRIP_TRAILING_WHITESPACE)

message(STATUS "Found libstdc++ at ${MINGW_LIBSTDCPP}")

message(STATUS "Found libgcc at ${MINGW_LIBGCC}")

add_subdirectory("wine/")

find_program(SEVENZIP_EXE NAMES 7z)

if(SEVENZIP_EXE)
    message(STATUS "Found 7z at ${SEVENZIP_EXE}")
else()
    message(FATAL_ERROR "7z not found. It is required for crosscompiling Maxima.")
endif()

# Avoid warnings in CMake >= 3.24:
# FIXME: Policy OLD is needed for texinfo, it does not build with the policy NEW
# But policy OLD is deprecated and may be removed in future CMake versions, see:
# https://cmake.org/cmake/help/latest/policy/CMP0135.html
# Hopefully texinfo solves that issue.
if (${CMAKE_VERSION} VERSION_GREATER_EQUAL 3.24)
    cmake_policy(SET CMP0135 OLD)
endif()

include(ExternalProject)


# Clisp (already a binary package just extract it...)
#
# What is the difference between clisp-2.49-win32-mingw-big.zip and clisp-2.49-win32-mingw-small.zip?
# What should be used for running Maxima?
externalproject_add(clisp
  URL "${CLISP_URL}"
  DOWNLOAD_DIR ${CMAKE_SOURCE_DIR}/downloads
  URL_MD5 ${CLISP_MD5}
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
)
install(DIRECTORY ${CMAKE_BINARY_DIR}/clisp-prefix/src/clisp/ DESTINATION clisp-${CLISPVERSION} COMPONENT Clisp)

add_subdirectory("sbcl/")

add_subdirectory("gnuplot/")

add_subdirectory("tcltk/")

add_subdirectory("texinfo/")

add_subdirectory("wxwidgets/")

add_subdirectory("wxmaxima/")

if(USE_VTK)
    add_subdirectory("vtk/")
    set(VTK_STYLE "")
else()
    set(VTK_STYLE "display: none;")
endif()

if(WITH_ABCL)
    add_subdirectory("abcl/")
    set(ABCL_ENABLE "--enable-abcl")
    set(ABCL_DEPENDS "abcl")
    set(ABCL_JAR "--with-abcl-jar=${CMAKE_BINARY_DIR}/abcl/abcl-prefix/src/abcl/abcl.jar")
else()
    set(ABCL_ENABLE "")
    set(ABCL_DEPENDS "")
    set(ABCL_JAR "")
endif()

configure_file("${CMAKE_SOURCE_DIR}/wine-clisp.sh.tmpl" "${CMAKE_BINARY_DIR}/wine-clisp.sh")
configure_file("${CMAKE_SOURCE_DIR}/wine-lisp.sh.tmpl" "${CMAKE_BINARY_DIR}/wine-lisp.sh")
configure_file("${CMAKE_SOURCE_DIR}/wine-sbcl.sh.tmpl" "${CMAKE_BINARY_DIR}/wine-sbcl.sh")

externalproject_add(maxima
  # first copy the maxima source to a build directory, since out-of-source-builds do not work
  DOWNLOAD_COMMAND rsync -a --exclude=crosscompile-windows/build/ "${CMAKE_SOURCE_DIR}/../"  "${CMAKE_BINARY_DIR}/maxima-prefix/src/maxima"
  DEPENDS clisp sbcl tcl tk texinfo ${ABCL_DEPENDS}
  BUILD_IN_SOURCE 1
  CONFIGURE_COMMAND sh -c "test -x ./bootstrap && ./bootstrap || return 0"
            COMMAND PATH=${CMAKE_BINARY_DIR}/texinfo-installroot/bin:$ENV{PATH} LANG=C ./configure --host=${HOST} --enable-clisp --with-clisp=${CMAKE_BINARY_DIR}/wine-clisp.sh --with-clisp-runtime=${CMAKE_BINARY_DIR}/wine-lisp.sh --enable-sbcl --with-sbcl=${CMAKE_BINARY_DIR}/wine-sbcl.sh ${ABCL_ENABLE} "${ABCL_JAR}" --with-default-lisp=${WITH_DEFAULT_LISP} --prefix=${WINDOWS_DRIVELETTER}:/maxima-${MAXIMAVERSION}
  # clisp-depends.mk is generated with "\" as path separator, not "/" - correct that...
  BUILD_COMMAND LANG=C $(MAKE) -C src clisp-depends.mk
        COMMAND sed -i s+\\\\+/+g src/clisp-depends.mk
        COMMAND PATH=${CMAKE_BINARY_DIR}/texinfo-installroot/bin:$ENV{PATH} LANG=C $(MAKE)
        COMMAND PATH=${CMAKE_BINARY_DIR}/texinfo-installroot/bin:$ENV{PATH} LANG=C $(MAKE) pdf
  INSTALL_COMMAND PATH=${CMAKE_BINARY_DIR}/texinfo-installroot/bin:$ENV{PATH} LANG=C $(MAKE) install DESTDIR=${CMAKE_BINARY_DIR}/maxima-installroot/
          COMMAND PATH=${CMAKE_BINARY_DIR}/texinfo-installroot/bin:$ENV{PATH} LANG=C $(MAKE) extradocinstall DESTDIR=${CMAKE_BINARY_DIR}/maxima-installroot/
)

option(STRIP_HELPERPROGRAMS "Strip the included helper programs (winkill, winkill_lib, maxima_longnames)." YES)

# crosscompiling winkill with autoconf does not work, compile it using CMake.
add_library(winkill_lib SHARED ${CMAKE_SOURCE_DIR}/../interfaces/xmaxima/win32/winkill_lib.c)
add_executable(winkill ${CMAKE_SOURCE_DIR}/../interfaces/xmaxima/win32/winkill.c)
set_target_properties(winkill_lib PROPERTIES PREFIX "") # remove 'lib' prefix from libwinkill_lib.dll
target_link_libraries(winkill winkill_lib)

# convert windows short names to long names (e.g.
# "C:/Users/TESTTE~1/AppData/Local/Temp" to "C:/Users/test test/AppData/Local/Temp")
# CLISP can (currently not handle short names.
add_executable(maxima_longnames maxima_longnames.c)
if(STRIP_HELPERPROGRAMS)
    add_custom_command(TARGET winkill POST_BUILD COMMAND ${CMAKE_STRIP} winkill.exe)
    add_custom_command(TARGET winkill_lib POST_BUILD COMMAND ${CMAKE_STRIP} winkill_lib.dll)
    add_custom_command(TARGET maxima_longnames POST_BUILD COMMAND ${CMAKE_STRIP} maxima_longnames.exe)
endif()
install(TARGETS winkill winkill_lib maxima_longnames COMPONENT Maxima RUNTIME DESTINATION bin LIBRARY DESTINATION bin/)
install(FILES "${CMAKE_SOURCE_DIR}/../interfaces/xmaxima/win32/win_signals.lisp" DESTINATION bin/ COMPONENT Maxima)

=== crosscompile-windows/abcl/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-or-later
set(ABCL_VERSION 1.9.1)
set(ABCL_MD5 "f230ca769c97420e500b6d5915263e1d")
set(ABCL_URL "https://abcl.org/releases/${ABCL_VERSION}/abcl-bin-${ABCL_VERSION}.tar.gz")

externalproject_add(abcl
  URL "${ABCL_URL}"
  DOWNLOAD_DIR ${CMAKE_SOURCE_DIR}/downloads
  URL_MD5 ${ABCL_MD5}
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
)

=== crosscompile-windows/gnuplot/CMakeLists.txt ===
# CMake file for crosscompiling Maxima/wxMaxima for Windows
# SPDX-License-Identifier: GPL-2.0-or-later
# Copyright (C) by Wolfgang Dautermann
# Time-stamp: "2022-03-18 20:34:12 villate"
# License GPLv2+: GNU GPL version 2 or later <http://gnu.org/licenses/gpl.html>
# This is free software: you are free to change and redistribute it.
# There is NO WARRANTY, to the extent permitted by law.

# If you want to use a updated version of a program,
# update the version number and the checksum.
# If no further patches are needed, you should get a
# updated setup-file automatically.


string(REPLACE "." "" GNUPLOTVERSIONWITHOUTDOTS "${GNUPLOTVERSION}")

if(BUILD_64BIT)
    set(GNUPLOTVERSION "5.4.6")
    string(REPLACE "." "" GNUPLOTVERSIONWITHOUTDOTS "${GNUPLOTVERSION}")
    set(GNUPLOT_MD5 "c142ec21af631271bc0112727db7f9cd")
    set(GNUPLOT_URL "https://sourceforge.net/projects/gnuplot/files/gnuplot/${GNUPLOTVERSION}/gp${GNUPLOTVERSIONWITHOUTDOTS}-win64-mingw-2.7z")
else()
    set(GNUPLOTVERSION "5.2.7")
    string(REPLACE "." "" GNUPLOTVERSIONWITHOUTDOTS "${GNUPLOTVERSION}")
    set(GNUPLOT_MD5 "228d25b13e4ce7358a99edc7efa574be")
    set(GNUPLOT_URL "https://sourceforge.net/projects/gnuplot/files/gnuplot/${GNUPLOTVERSION}/gp${GNUPLOTVERSIONWITHOUTDOTS}-win32-mingw.7z")
endif()

# Gnuplot (already a binary package just extract it...)
externalproject_add(gnuplot
  URL "${GNUPLOT_URL}"
  DOWNLOAD_DIR ${CMAKE_SOURCE_DIR}/downloads
  URL_MD5 ${GNUPLOT_MD5}
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
)
install(DIRECTORY ${CMAKE_BINARY_DIR}/gnuplot/gnuplot-prefix/src/gnuplot/ DESTINATION gnuplot COMPONENT Gnuplot)

=== crosscompile-windows/tcltk/CMakeLists.txt ===
# CMake file for crosscompiling Maxima/wxMaxima for Windows
# SPDX-License-Identifier: GPL-2.0-or-later
# Copyright (C) by Wolfgang Dautermann
# License GPLv2+: GNU GPL version 2 or later <http://gnu.org/licenses/gpl.html>
# This is free software: you are free to change and redistribute it.
# There is NO WARRANTY, to the extent permitted by law.

# If you want to use a updated version of a program,
# update the version number and the checksum.
# If no further patches are needed, you should get a
# updated setup-file automatically.

set(TCLVERSION "8.6.13")
set(TKVERSION  "8.6.13")

set(TCL_MD5 "0e4358aade2f5db8a8b6f2f6d9481ec2")
set(TK_MD5  "95adc33d55a133ee29bc9f81efdf31b2")

set(TCL_URL "https://prdownloads.sourceforge.net/tcl/tcl${TCLVERSION}-src.tar.gz")
set(TK_URL  "https://prdownloads.sourceforge.net/tcl/tk${TKVERSION}-src.tar.gz")

if(BUILD_64BIT)
    set(CONFIGURE64BIT "--enable-64bit")
else()
    set(CONFIGURE64BIT "")
endif()


# build tcl/tk (required for xmaxima and the Lisp selection tool)
externalproject_add(tcl
  URL "${TCL_URL}"
  DOWNLOAD_DIR ${CMAKE_SOURCE_DIR}/downloads
  URL_MD5 ${TCL_MD5}
  CONFIGURE_COMMAND ${CMAKE_BINARY_DIR}/tcltk/tcl-prefix/src/tcl/win/configure --build=${BUILDHOST} --host=${HOST} ${CONFIGURE64BIT} --enable-shared=no --prefix=${WINDOWS_DRIVELETTER}:/maxima-${MAXIMAVERSION}
  BUILD_COMMAND $(MAKE)
        COMMAND $(MAKE) install
)
install(DIRECTORY ${CMAKE_BINARY_DIR}/tcltk/tcl-prefix/src/tcl-build/${WINDOWS_DRIVELETTER}:/maxima-${MAXIMAVERSION}/ DESTINATION . COMPONENT TclTk)

externalproject_add(tk
  URL "${TK_URL}"
  DOWNLOAD_DIR ${CMAKE_SOURCE_DIR}/downloads
  URL_MD5 ${TK_MD5}
  DEPENDS tcl
  CONFIGURE_COMMAND ${CMAKE_BINARY_DIR}/tcltk/tk-prefix/src/tk/win/configure --build=${BUILDHOST} --host=${HOST} ${CONFIGURE64BIT} --enable-shared=no --with-tcl=${CMAKE_BINARY_DIR}/tcltk/tcl-prefix/src/tcl-build/${WINDOWS_DRIVELETTER}:/maxima-${MAXIMAVERSION}/lib --prefix=${WINDOWS_DRIVELETTER}:/maxima-${MAXIMAVERSION}
  BUILD_COMMAND $(MAKE)
        COMMAND $(MAKE) install
)
install(DIRECTORY ${CMAKE_BINARY_DIR}/tcltk/tk-prefix/src/tk-build/${WINDOWS_DRIVELETTER}:/maxima-${MAXIMAVERSION}/ DESTINATION . COMPONENT TclTk)

=== crosscompile-windows/vtk/CMakeLists.txt ===
# CMake file for crosscompiling Maxima/wxMaxima for Windows
# SPDX-License-Identifier: GPL-2.0-or-later
# Copyright (C) by Wolfgang Dautermann
# License GPLv2+: GNU GPL version 2 or later <http://gnu.org/licenses/gpl.html>
# This is free software: you are free to change and redistribute it.
# There is NO WARRANTY, to the extent permitted by law.

# If you want to use a updated version of a program,
# update the version number and the checksum.
# If no further patches are needed, you should get a
# updated setup-file automatically.


if(BUILD_64BIT)
    set(VTK_MD5 "f75e6f49c167c464192fbc8ef473954a")
    set(VTK_INSTALLERNAME "vtkpython-7.1.1-Windows-64bit.exe")
    set(VTK_URL "https://www.vtk.org/files/release/7.1/${VTK_INSTALLERNAME}")
else()
    set(VTK_MD5 "8d8b0878be81a0ab471e929f828dfe9a")
    set(VTK_INSTALLERNAME "vtkpython-6.3.0-Windows-32bit.exe")
    set(VTK_URL "https://www.vtk.org/files/release/6.3/${VTK_INSTALLERNAME}")
endif()



externalproject_add(vtk
    URL "${VTK_URL}"
    DOWNLOAD_DIR ${CMAKE_SOURCE_DIR}/downloads
    DOWNLOAD_NO_EXTRACT 1
    URL_MD5 ${VTK_MD5}
    CONFIGURE_COMMAND ""
    BUILD_COMMAND ""
    INSTALL_COMMAND ""
)
# older versions of 7z extract the contents of the VTK installer
# into the directory "$_OUTDIR/bin/" newer into "bin/". Don't know why.
# To make this uniform, test if the directory "${CMAKE_BINARY_DIR}/vtk/\$_OUTDIR/bin/"
# exists, and rename the directory.
ExternalProject_Add_Step(vtk extract
    COMMENT "Performing extraction step for 'VTK'"
    COMMAND mkdir -p "${CMAKE_BINARY_DIR}/vtk" && cd "${CMAKE_BINARY_DIR}/vtk" && ${SEVENZIP_EXE} x -y "${CMAKE_SOURCE_DIR}/downloads/${VTK_INSTALLERNAME}" && test -d "${CMAKE_BINARY_DIR}/vtk/\$_OUTDIR/bin/" && mv "${CMAKE_BINARY_DIR}/vtk/\$_OUTDIR/bin/" "${CMAKE_BINARY_DIR}/vtk/bin/" || exit 0
    DEPENDEES download
    DEPENDERS patch
)

install(DIRECTORY "${CMAKE_BINARY_DIR}/vtk/bin/" DESTINATION vtk/ COMPONENT VTK)

=== crosscompile-windows/wxmaxima/CMakeLists.txt ===
# CMake file for crosscompiling Maxima/wxMaxima for Windows
# SPDX-License-Identifier: GPL-2.0-or-later
# Copyright (C) by Wolfgang Dautermann
# License GPLv2+: GNU GPL version 2 or later <http://gnu.org/licenses/gpl.html>
# This is free software: you are free to change and redistribute it.
# There is NO WARRANTY, to the extent permitted by law.

# If you want to use a updated version of a program,
# update the version number and the checksum.
# If no further patches are needed, you should get a
# updated setup-file automatically.

set(WXMAXIMAVERSION "23.05.1")

set(WXMAXIMA_MD5 "b5c69589e9d8eb145984c5838f278fd3")

set(WXMAXIMA_URL "https://github.com/wxMaxima-developers/wxmaxima/archive/refs/tags/Version-${WXMAXIMAVERSION}.tar.gz")

set(WXMAXIMA_GIT "https://github.com/wxmaxima-developers/wxmaxima.git")

if(USE_WXMAXIMA_GIT)
    find_package(Git REQUIRED)
    message(STATUS "Cloning or updating local wxmaxima git repository.")
    execute_process(COMMAND mkdir -p ${CMAKE_SOURCE_DIR}/downloads/wxmaxima-git
                    COMMAND sh -c "test -d wxmaxima-git/.git || \"${GIT_EXECUTABLE}\" clone \"${WXMAXIMA_GIT}\" wxmaxima-git"
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/downloads)

    execute_process(COMMAND sh -c "test -d .git && \"${GIT_EXECUTABLE}\" pull"
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/downloads/wxmaxima-git)

    externalproject_add(wxmaxima-git
        GIT_REPOSITORY ${CMAKE_SOURCE_DIR}/downloads/wxmaxima-git
        GIT_TAG main
        DEPENDS wxwidgets
        # search wx-config here - do not use the host wx-config
        # had to set CMAKE_LIBRARY_PATH=/usr/${HOST}/lib - libraries for mingw are installed there, but CMake (>3.8)
        # tries to check all the libraries reported by wx-config, but does not check this directory...
        CMAKE_CACHE_ARGS "-DCMAKE_PROGRAM_PATH:PATH=${CMAKE_BINARY_DIR}/wxwidgets/wxwidgets-prefix/src/wxwidgets-build"
        CMAKE_ARGS -DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME} -DCMAKE_C_COMPILER=${CMAKE_C_COMPILER} -DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER} -DCMAKE_RC_COMPILER=${CMAKE_RC_COMPILER} -DCMAKE_LIBRARY_PATH=/usr/${HOST}/lib -DCMAKE_INSTALL_PREFIX=${WINDOWS_DRIVELETTER}:/maxima-${MAXIMAVERSION} -DCMAKE_BUILD_TYPE=DEBUG
        BUILD_COMMAND $(MAKE)
    )
    install(DIRECTORY ${CMAKE_BINARY_DIR}/wxmaxima/wxmaxima-git-prefix/src/wxmaxima-git-build/${WINDOWS_DRIVELETTER}\:/maxima-${MAXIMAVERSION}/ DESTINATION . COMPONENT wxMaxima)
else()
    externalproject_add(wxmaxima
        URL "${WXMAXIMA_URL}"
        DOWNLOAD_DIR ${CMAKE_SOURCE_DIR}/downloads
        DOWNLOAD_NAME wxmaxima-${WXMAXIMAVERSION}.tar.gz
        URL_MD5 ${WXMAXIMA_MD5}
        DEPENDS wxwidgets
        # search wx-config here - do not use the host wx-config
        # had to set CMAKE_LIBRARY_PATH=/usr/${HOST}/lib - libraries for mingw are installed there, but CMake (>3.8)
        # tries to check all the libraries reported by wx-config, but does not check this directory...
        CMAKE_CACHE_ARGS "-DCMAKE_PROGRAM_PATH:PATH=${CMAKE_BINARY_DIR}/wxwidgets/wxwidgets-prefix/src/wxwidgets-build"
        CMAKE_ARGS -DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME} -DCMAKE_C_COMPILER=${CMAKE_C_COMPILER} -DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER} -DCMAKE_RC_COMPILER=${CMAKE_RC_COMPILER} -DCMAKE_LIBRARY_PATH=/usr/${HOST}/lib -DCMAKE_INSTALL_PREFIX=${WINDOWS_DRIVELETTER}:/maxima-${MAXIMAVERSION}
        BUILD_COMMAND $(MAKE)
    )
    install(DIRECTORY ${CMAKE_BINARY_DIR}/wxmaxima/wxmaxima-prefix/src/wxmaxima-build/${WINDOWS_DRIVELETTER}\:/maxima-${MAXIMAVERSION}/ DESTINATION . COMPONENT wxMaxima)
endif()


# wxMaxima uses C++ threads, include the required mingw library.
execute_process(COMMAND "${CMAKE_CXX_COMPILER}" -print-file-name=libwinpthread-1.dll OUTPUT_VARIABLE MINGW_LIBWINPTHREAD OUTPUT_STRIP_TRAILING_WHITESPACE)
message(STATUS "Found libwinpthread at ${MINGW_LIBWINPTHREAD}")

# Include DLLs from the current Mingw environment.
install(FILES "${MINGW_LIBWINPTHREAD}" DESTINATION bin/ COMPONENT wxMaxima)

=== crosscompile-windows/wxwidgets/CMakeLists.txt ===
# CMake file for crosscompiling Maxima/wxMaxima for Windows
# SPDX-License-Identifier: GPL-2.0-or-later
# Copyright (C) by Wolfgang Dautermann
# License GPLv2+: GNU GPL version 2 or later <http://gnu.org/licenses/gpl.html>
# This is free software: you are free to change and redistribute it.
# There is NO WARRANTY, to the extent permitted by law.

# If you want to use a updated version of a program,
# update the version number and the checksum.
# If no further patches are needed, you should get a
# updated setup-file automatically.

set(WXWIDGETSVERSION "3.2.2.1")
set(WXWIDGETS_MD5 "45bd5f56a06e7c4ca7caf6c0b4d5d506")
set(WXWIDGETS_URL "https://github.com/wxWidgets/wxWidgets/releases/download/v${WXWIDGETSVERSION}/wxWidgets-${WXWIDGETSVERSION}.tar.bz2")

# Build wxWidgets static library (required for wxMaxima)
# We link statically, so the installation of the library is not
# necessary, we only need the locale files. But fortunately
# there is a make target, which does install the locale files only.
externalproject_add(wxwidgets
  URL "${WXWIDGETS_URL}"
  DOWNLOAD_DIR ${CMAKE_SOURCE_DIR}/downloads
  URL_MD5 ${WXWIDGETS_MD5}
  CONFIGURE_COMMAND ${CMAKE_BINARY_DIR}/wxwidgets/wxwidgets-prefix/src/wxwidgets/configure --disable-shared --disable-compat28 --with-zlib=builtin --with-libjpeg=builtin --without-libtiff --with-libpng=builtin --with-expat=builtin --build=${BUILDHOST} --host=${HOST} --enable-accessibility
  BUILD_COMMAND $(MAKE)
  INSTALL_COMMAND $(MAKE) locale_install "DESTDIR=${CMAKE_BINARY_DIR}/wxwidgets-installroot"
)

# Install wxWidgets locale files only.
install(DIRECTORY "${CMAKE_BINARY_DIR}/wxwidgets-installroot/usr/local/share/" DESTINATION share/ COMPONENT wxMaxima)

=== debian/changelog ===
maxima (5.47.0-9) unstable; urgency=medium

  * Bug fix: "FTBFS: dpkg-buildpackage: error: debian/rules binary
    subprocess returned exit status 2", thanks to Santiago Vila (Closes:
    #1114203).  Add top level dir to make install in debian/rules

 -- Camm Maguire <camm@debian.org>  Mon, 22 Sep 2025 09:21:33 -0400

maxima (5.47.0-8) unstable; urgency=medium

  * package cleanups
  * Bug fix: "ftbfs with GCC-15", thanks to Matthias Klose (Closes:
    #1097368).
  * Bug fix: "FTBFS on i386: dpkg-buildpackage: error: debian/rules build
    subprocess returned exit status 2", thanks to Lucas Nussbaum (Closes:
    #1091578).

 -- Camm Maguire <camm@debian.org>  Wed, 14 May 2025 10:43:05 -0400

maxima (5.47.0-7) unstable; urgency=high

  * do not insist on testsuite perfection for now

 -- Camm Maguire <camm@debian.org>  Sat, 26 Apr 2025 19:00:00 -0400

maxima (5.47.0-6) unstable; urgency=high

  * build-dep gcl27

 -- Camm Maguire <camm@debian.org>  Sat, 26 Apr 2025 12:29:59 -0400

maxima (5.47.0-5) unstable; urgency=medium

  * Bug fix: "Fails to build source after successful build", thanks to
    Lucas Nussbaum (Closes: #1046512).  iconv exits with code 1, skip
    over for now.

 -- Camm Maguire <camm@debian.org>  Tue, 22 Oct 2024 09:43:34 -0400

maxima (5.47.0-4) unstable; urgency=medium

  * define ELCDIR in maxima-remove, thanks to Agustin Martin
  * misdirected bug, (Closes: #1031520).
  * maxima-emacs depends on texlive-binaries, (Closes: #1030064).

 -- Camm Maguire <camm@debian.org>  Sat, 29 Jun 2024 13:01:00 -0400

maxima (5.47.0-3) unstable; urgency=high

  * Bug fix: "maxima-emacs again not installable with xemacs21", thanks to
    Agustin Martin (Closes: #1066086).

 -- Camm Maguire <camm@debian.org>  Mon, 24 Jun 2024 11:10:13 -0400

maxima (5.47.0-2) unstable; urgency=medium

  * Bug fix: "no Homepage field", thanks to Jakub Wilk (Closes: #1019063).
  * Bug fix: "insecure use of /tmp", thanks to Evgeny Kapun (Closes:
    #965154).

 -- Camm Maguire <camm@debian.org>  Fri, 07 Jun 2024 16:26:20 -0400

maxima (5.47.0-1) unstable; urgency=medium

  * New upstream release.
  * Bug fix: "CVE-2024-34490", thanks to Moritz Mühlenhoff (Closes:
    #1071630).

 -- Camm Maguire <camm@debian.org>  Thu, 23 May 2024 09:00:20 -0400

maxima (5.46.0-11) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Tue, 14 Feb 2023 08:24:08 -0500

maxima (5.46.0-10) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Mon, 13 Feb 2023 10:46:36 -0500

maxima (5.46.0-9) unstable; urgency=medium

  * build-dep latest gcl
  * Bug fix: "tab causes &quot;fatal error&quot; and &quot;Segmentation
    violation&quot;", thanks to Jakub Wilk (Closes: #1030892).

 -- Camm Maguire <camm@debian.org>  Sun, 12 Feb 2023 15:55:36 -0500

maxima (5.46.0-8) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Sun, 08 Jan 2023 17:08:16 -0500

maxima (5.46.0-7) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Sun, 25 Dec 2022 17:58:09 -0500

maxima (5.46.0-6) unstable; urgency=medium

  * build-dep latest gcl
  * adjust for fixed gcl time coding functions

 -- Camm Maguire <camm@debian.org>  Thu, 22 Dec 2022 19:07:07 -0500

maxima (5.46.0-5) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 21 Dec 2022 14:52:05 -0500

maxima (5.46.0-4) unstable; urgency=medium

  * build-dep latest gcl
  * prune build depends

 -- Camm Maguire <camm@debian.org>  Wed, 21 Dec 2022 12:53:37 -0500

=== debian/control ===
Source: maxima
Section: math
Priority: optional
Maintainer: Camm Maguire <camm@debian.org>
Homepage: https://maxima.sourceforge.io/
Build-Depends: gcl27 ( >= 2.7.1-4 ) , texinfo, automake, debhelper-compat ( = 13 ), autoconf, gawk | awk, texlive-latex-recommended, sharutils, python3, tex-common
Standards-Version: 4.7.2

Package: maxima
Architecture: any
Depends:  ${shlibs:Depends}, ${misc:Depends}
Recommends: maxima-share, gnuplot-x11
Suggests: texmacs, maxima-doc, xmaxima, maxima-emacs, wish
Description: Computer algebra system -- base system
 Maxima is a fully symbolic computation program.  It is full featured
 doing symbolic manipulation of polynomials, matrices, rational
 functions, integration, Todd-coxeter methods for finite group
 analysis, graphing, multiple precision floating point computation.
 It has a symbolic source level debugger for maxima code.  Maxima is
 based on the original Macsyma developed at MIT in the 1970s.  It is
 quite reliable, and has good garbage collection, and no memory leaks.
 It comes with hundreds of self tests.
 .
 This package contains the main executables and base system files.

Package: maxima-src
Architecture: all
Depends: ${misc:Depends}
Description: Computer algebra system -- source code
 Maxima is a fully symbolic computation program.  It is full featured
 doing symbolic manipulation of polynomials, matrices, rational
 functions, integration, Todd-coxeter methods for finite group
 analysis, graphing, multiple precision floating point computation.
 It has a symbolic source level debugger for maxima code.  Maxima is
 based on the original Macsyma developed at MIT in the 1970s.  It is
 quite reliable, and has good garbage collection, and no memory leaks.
 It comes with hundreds of self tests.
 .
 This package contains the lisp source code.

Package: maxima-test
Architecture: all
Depends: maxima (>= ${binary:Version}), maxima-src (>= ${source:Version}), maxima-share (>= ${source:Version}), ${misc:Depends}
Description: Computer algebra system -- test suite
 Maxima is a fully symbolic computation program.  It is full featured
 doing symbolic manipulation of polynomials, matrices, rational
 functions, integration, Todd-coxeter methods for finite group
 analysis, graphing, multiple precision floating point computation.
 It has a symbolic source level debugger for maxima code.  Maxima is
 based on the original Macsyma developed at MIT in the 1970s.  It is
 quite reliable, and has good garbage collection, and no memory leaks.
 It comes with hundreds of self tests.
 .
 This package contains a build integrity test suite.

Package: maxima-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Replaces: maxima (<< ${binary:Version})
Description: Computer algebra system -- documentation
 Maxima is a fully symbolic computation program.  It is full featured
 doing symbolic manipulation of polynomials, matrices, rational
 functions, integration, Todd-coxeter methods for finite group
 analysis, graphing, multiple precision floating point computation.
 It has a symbolic source level debugger for maxima code.  Maxima is
 based on the original Macsyma developed at MIT in the 1970s.  It is
 quite reliable, and has good garbage collection, and no memory leaks.
 It comes with hundreds of self tests.
 .
 This package contains most of the documentation.

Package: xmaxima
Architecture: any
Depends:  tk, maxima (>= ${binary:Version}), maxima-doc (>= ${source:Version}), maxima-test (>= ${source:Version}), ${misc:Depends}, sensible-utils
Recommends: mailcap, postscript-viewer, pdf-viewer
Suggests: texmacs
Replaces: maxima (<< ${binary:Version})
Description: Computer algebra system -- x interface
 Maxima is a fully symbolic computation program.  It is full featured
 doing symbolic manipulation of polynomials, matrices, rational
 functions, integration, Todd-coxeter methods for finite group
 analysis, graphing, multiple precision floating point computation.
 It has a symbolic source level debugger for maxima code.  Maxima is
 based on the original Macsyma developed at MIT in the 1970s.  It is
 quite reliable, and has good garbage collection, and no memory leaks.
 It comes with hundreds of self tests.
 .
 This package contains an X Windows interface using the tcl/tk 
 libraries. 

Package: maxima-emacs
Depends:  maxima (>= ${binary:Version}), emacs-gtk | emacsen, mmm-mode, emacsen-common (>= 1.4.14), texlive-binaries, ${misc:Depends}, texlive-latex-recommended, maxima-doc (>= ${source:Version})
Recommends: mailcap, postscript-viewer, pdf-viewer
Architecture: all
Replaces: maxima (<< ${binary:Version})
Description: Computer algebra system -- emacs interface
 Maxima is a fully symbolic computation program.  It is full featured
 doing symbolic manipulation of polynomials, matrices, rational
 functions, integration, Todd-coxeter methods for finite group
 analysis, graphing, multiple precision floating point computation.
 It has a symbolic source level debugger for maxima code.  Maxima is
 based on the original Macsyma developed at MIT in the 1970s.  It is
 quite reliable, and has good garbage collection, and no memory leaks.
 It comes with hundreds of self tests.
 .
 This package contains a tradition emacs interface, together with a
 newer imaxima interface supporting inline imaging and HTML export
 under a specialized imath mode.

Package: maxima-share
Architecture: all
Depends:  maxima (>= ${binary:Version}), ${misc:Depends}
Replaces: maxima (<< ${binary:Version})
Description: Computer algebra system -- extra code
 Maxima is a fully symbolic computation program.  It is full featured
 doing symbolic manipulation of polynomials, matrices, rational
 functions, integration, Todd-coxeter methods for finite group
 analysis, graphing, multiple precision floating point computation.
 It has a symbolic source level debugger for maxima code.  Maxima is
 based on the original Macsyma developed at MIT in the 1970s.  It is
 quite reliable, and has good garbage collection, and no memory leaks.
 It comes with hundreds of self tests.
 .
 This package contains a set of contributed routines and add-on 
 packages.

=== debian/rules ===
#!/usr/bin/make -f
#-*- makefile -*-
# Made with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# Some lines taken from debmake, by Christoph Lameter.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#FIXME remove when converting to dh
export SOURCE_DATE_EPOCH = $(shell date -d "$$(dpkg-parsechangelog -SDate)" +%s)

SAVES:=interfaces/emacs/imaxima/version.texi interfaces/emacs/imaxima/stamp-vti \
       interfaces/emacs/imaxima/imaxima.info src/autoconf-variables.lisp \
       src/share-subdirs_autogenerated.lisp src/share-subdirs.lisp doc/info/texi2html.init \
       doc/info/category-macros.texi

debian/save/%: %
	[ -e $@ ] || (mkdir -p $(@D) && cp $< $@)

MVERS:=$(shell head -n 1 debian/changelog | cut -f2 -d\  | tr -d '()' | cut -f1 -d-)
build: build-arch build-indep
build-arch: build-stamp
build-indep: #build-stamp
build-stamp: $(addprefix debian/save/,$(SAVES))
	dh_testdir

	dh_autoreconf

	echo '(progn (setq si::*optimize-maximum-pages* nil)(when (fboundp (quote si::sgc-on)) (fmakunbound (quote si::sgc-on)))(si::save-system "gcl"))' | GCL_ANSI=t gcl27

	git_found=false PATH=$$(pwd):$$PATH GCL_ANSI=t ./configure --enable-gcl \
		--prefix=/usr \
		--libexec=/usr/lib \
		--mandir=/usr/share/man \
		--infodir=/usr/share/info 

	cp debian/favicon.ico doc/info/figures/

	rm -f src/sys-proclaim.lisp

	PATH=$$(pwd):$$PATH GCL_ANSI=t $(MAKE)

	touch -r src/share-subdirs_autogenerated.lisp src/share-subdirs.lisp
	touch -r src/gcl-depends.mk src/binary-gcl/maxima

	echo ':lisp (setq maxima::*maxima-started* nil si::*optimize-maximum-pages* t)(si::gbc t)(si::save-system "foo")' | \
	HOME=$$(pwd) \
	./maxima-local && mv foo src/binary-gcl/maxima


	chmod +x ./maxima-local
	touch tests/tests-gcl.log
	HOME=$$(pwd) \
	./maxima-local -g --lisp=gcl --batch-string="run_testsuite(share_tests=true);"  >tmp 2>&1 & \
		j=$$! ; echo Waiting on pid $$j ; \
		tail -f --pid=$$j --retry tests/tests-gcl.log tmp & wait $$j

	touch tmp
	cat tmp >debian/test_results.out

	rm -f tmp

	echo ':lisp (setq si::*readline-prefix* "MAXIMA::$$")(setq maxima::*maxima-started* nil maxima::*maxima-index-dir* "/usr/share/doc/maxima/info")(si::save-system "foo")' | \
	HOME=$$(pwd) \
	./maxima-local && mv foo src/binary-gcl/maxima

	touch build-stamp

BOOK:=debian/maximabook-19-Sept-2004.pdf

clean:
	dh_testdir
	dh_testroot

	! [ -e Makefile ] || $(MAKE) clean
	! [ -d debian/save ] || (cd debian/save; find -type f -exec cp {} ../../{} \; ; \
				 cd .. ; rm -rf save)
	rm -rf $(BOOK) src/binary-gcl binary gcl src/sys-proclaim.lisp tests/tests-gcl.log
	rm -rf admin/Makefile config.log config.status crosscompile-windows/Makefile\
		crosscompile-windows/wxwidgets/Makefile demo/Makefile doc/emaxima/Makefile\
		doc/info/de/Makefile doc/info/de.utf8/Makefile doc/info/es/include-maxima.texi\
		doc/info/es/Makefile doc/info/es.utf8/Makefile\
		doc/info/Makefile doc/info/pt_BR/Makefile doc/info/pt_BR.utf8/Makefile\
		doc/info/pt/include-maxima.texi doc/info/pt/Makefile doc/info/pt.utf8/Makefile\
		doc/intromax/Makefile doc/Makefile doc/man/Makefile doc/man/maxima.1 doc/man/ru/maxima.1\
		doc/share/Makefile interfaces/emacs/emaxima/Makefile interfaces/emacs/imaxima/Makefile\
		interfaces/emacs/Makefile interfaces/emacs/misc/Makefile interfaces/Makefile\
		interfaces/xmaxima/autoconf-variables.tcl interfaces/xmaxima/doc/figures/Makefile\
		interfaces/xmaxima/doc/Makefile interfaces/xmaxima/Makefile interfaces/xmaxima/msgs/Makefile\
		interfaces/xmaxima/Tkmaxima/Header.tcl interfaces/xmaxima/win32/Makefile interfaces/xmaxima/xmaxima\
		lisp-utils/Makefile locale/Makefile Makefile maxima.iss maxima-local maxima.spec plotting/Makefile\
		plotting/mgnuplot share/contrib/integration/Makefile share/contrib/Makefile\
		share/contrib/maxima-odesolve/Makefile share/draw/Makefile share/logic/Makefile share/Makefile\
		src/gcl-depends.mk src/Makefile src/maxima src/maxima.bat src/rmaxima tests/Makefile xmaxima-local\
		interfaces/xmaxima/Tkmaxima/tclIndex desktopintegration/Makefile
	rm -rf bin/interfaces bin/doc bin/src bin/xmaxima
	rm -f doc/info/figures/Makefile
	rm -f tmp
	rm -f src/gcl-depends.mk.tmp src/startmaxima_abcl.sh
	rm -f tests/test.sh
	rm -f doc/info/build_html.sh # doc/info/extract_categories.sh
	cd doc/info && rm -f  Affine.html  Bernstein_002dpkg.html  Bug-Detection-and-Reporting.html  Command-Line.html  Data-Types-and-Structures.html \
		Debugging.html  Differential-Equations.html  Differentiation.html  Documentation-Categories.html  Elliptic-Functions.html  Equations.html  \
		Error-and-warning-messages.html  Evaluation.html  Expressions.html  File-Input-and-Output.html  Function-Definition.html\
		Function-and-Variable-Index.html  Groups.html  Help.html  Integration.html  Introduction-to-Maxima.html  Limits.html  Mathematical-Functions.html\
		Matrices-and-Linear-Algebra.html  Maximas-Database.html  Miscellaneous-Options.html  Number-Theory.html  Numerical.html  Operators.html  Plotting.html\
		Polynomials.html  Program-Flow.html  Rules-and-Patterns.html  Runtime-Environment.html  Sets.html  Simplification.html  Special-Functions.html\
		Sums-Products-and-Series.html  Symmetries.html  alt_002ddisplay_002dpkg.html  asympa_002dpkg.html  atensor.html  augmented_005flagrangian_002dpkg.html\
		bitwise_002dpkg.html  bode_002dpkg.html  celine_002dpkg.html  clebsch_005fgordan_002dpkg.html  cobyla_002dpkg.html  combinatorics_002dpkg.html  \
		contrib_005fode_002dpkg.html  ctensor.html  descriptive_002dpkg.html  diag_002dpkg.html  distrib_002dpkg.html  draw_002dpkg.html  drawdf_002dpkg.html\
		dynamics_002dpkg.html  engineering_002dformat_002dpkg.html  ezunits_002dpkg.html  f90_002dpkg.html  finance_002dpkg.html  fractals_002dpkg.html  \
		ggf_002dpkg.html  graphs_002dpkg.html  grobner_002dpkg.html  impdiff_002dpkg.html  index.html  interpol_002dpkg.html  itensor.html  lapack_002dpkg.html  \
		lbfgs_002dpkg.html  lindstedt_002dpkg.html  linearalgebra_002dpkg.html  lsquares_002dpkg.html  makeOrders_002dpkg.html  minpack_002dpkg.html  \
		mnewton_002dpkg.html  numericalio_002dpkg.html  odepack_002dpkg.html  operatingsystem_002dpkg.html  opsubst_002dpkg.html  orthopoly_002dpkg.html\
		ratpow_002dpkg.html  romberg_002dpkg.html  simplex_002dpkg.html  simplification_002dpkg.html  solve_005frec_002dpkg.html  stats_002dpkg.html\
		stirling_002dpkg.html  stringproc_002dpkg.html  to_005fpoly_005fsolve_002dpkg.html  unit_002dpkg.html  wrstcse_002dpkg.html  zeilberger_002dpkg.html 

	rm -f 	doc/man/de/Makefile doc/man/de/maxima.1 doc/man/ru/Makefile \
		interfaces/xmaxima/doc/Command_002dline-options.html interfaces/xmaxima/doc/Concept-Index.html \
		interfaces/xmaxima/doc/Entering-commands.html interfaces/xmaxima/doc/Getting-Help.html \
		interfaces/xmaxima/doc/Main-Window.html interfaces/xmaxima/doc/Openmath-plots.html \
		interfaces/xmaxima/doc/Session-control.html interfaces/xmaxima/doc/The-browser.html \
		interfaces/xmaxima/doc/index.html doc/info/de/build_html.sh doc/info/ja/Makefile doc/info/ru/Makefile \
		interfaces/xmaxima/doc/Xmaxima-plots.html share/contrib/symplectic_ode/Makefile


	rm -f $(INSTALLS)
	rm -f debian/ChangeLog doc/info/de/include-maxima.texi doc/info/ja/include-maxima.texi doc/info/js_licenses.html doc/info/math.m4 doc/info/pt_BR/include-maxima.texi doc/info/ru/include-maxima.texi doc/info/texi2html-7.init share/nelder_mead/Makefile 

	dh_autoreconf_clean
	dh_clean


LOC_DOC=<a href=file://usr/share/doc/maxima/html/maxima_toc.html> (local copy) </a>

debian/%.install: debian/%.install.in
	cat $< | sed "s,@MVERS@,$(MVERS),g" >$@

INSTALLS:=$(shell ls -1 debian/*.install.in | sed 's,\.in$$,,1')

debian/%.pdf: debian/%.pdf.uu
	cat $< | uudecode >$@

CHANGELOGS:=$(shell ls -1 ChangeLog*)
debian/ChangeLog: $(CHANGELOGS)
	for i in $^; do echo "==========">>$@;echo "File: $$i" >>$@;echo "==========">>$@;cat $$i >>$@; done

install: install-stamp
install-stamp: build-stamp $(BOOK) $(INSTALLS) debian/ChangeLog

## maxima 5.49.0

=== debian/changelog ===
maxima (5.49.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Debianization:
    - d/control:
      - Uploaders field, add current Maintainer and myself;
      - Vcs-{Git,Browser}, bring to Salsa;
    - d/copyright, comment move to Salsa;
    - d/*, minimalistic refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Tue, 10 Feb 2026 10:45:33 +0000

=== debian/control ===
--- 
+++ 
@@ -2,6 +2,10 @@
 Section: math
 Priority: optional
 Maintainer: Camm Maguire <camm@debian.org>
+Uploaders: Jerome Benoit <calculus@rezozer.net>,
+           Camm Maguire <camm@debian.org>
+Vcs-Git: https://salsa.debian.org/debian/maxima.git
+Vcs-Browser: https://salsa.debian.org/debian/maxima
 Homepage: https://maxima.sourceforge.io/
 Build-Depends: gcl27 ( >= 2.7.1-4 ) , texinfo, automake, debhelper-compat ( = 13 ), autoconf, gawk | awk, texlive-latex-recommended, sharutils, python3, tex-common
 Standards-Version: 4.7.2

=== debian/rules ===
--- 
+++ 
@@ -10,9 +10,14 @@
 #FIXME remove when converting to dh
 export SOURCE_DATE_EPOCH = $(shell date -d "$$(dpkg-parsechangelog -SDate)" +%s)
 
+##SAVES:=interfaces/emacs/imaxima/version.texi interfaces/emacs/imaxima/stamp-vti \
+##       interfaces/emacs/imaxima/imaxima.info src/autoconf-variables.lisp \
+##       src/share-subdirs_autogenerated.lisp src/share-subdirs.lisp doc/info/texi2html.init \
+##       doc/info/category-macros.texi
+
 SAVES:=interfaces/emacs/imaxima/version.texi interfaces/emacs/imaxima/stamp-vti \
        interfaces/emacs/imaxima/imaxima.info src/autoconf-variables.lisp \
-       src/share-subdirs_autogenerated.lisp src/share-subdirs.lisp doc/info/texi2html.init \
+       doc/info/texi2html.init \
        doc/info/category-macros.texi
 
 debian/save/%: %
@@ -41,7 +46,7 @@
 
 	PATH=$$(pwd):$$PATH GCL_ANSI=t $(MAKE)
 
-	touch -r src/share-subdirs_autogenerated.lisp src/share-subdirs.lisp
+####	touch -r src/share-subdirs_autogenerated.lisp src/share-subdirs.lisp
 	touch -r src/gcl-depends.mk src/binary-gcl/maxima
 
 	echo ':lisp (setq maxima::*maxima-started* nil si::*optimize-maximum-pages* t)(si::gbc t)(si::save-system "foo")' | \
@@ -142,9 +147,3 @@
 debian/%.pdf: debian/%.pdf.uu
 	cat $< | uudecode >$@
 
-CHANGELOGS:=$(shell ls -1 ChangeLog*)
-debian/ChangeLog: $(CHANGELOGS)
-	for i in $^; do echo "==========">>$@;echo "File: $$i" >>$@;echo "==========">>$@;cat $$i >>$@; done
-
-install: install-stamp
-install-stamp: build-stamp $(BOOK) $(INSTALLS) debian/ChangeLog
